/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
//////////////////////////////////////////////////////////////
//
// Header file for DrcmapControl
//
//    This file is generated by BuildXcessory. DO NOT MODIFY. 
//    USE SUBCLASSING INSTEAD
//
//    This class is a user interface "component", as described
//    in "Object-Oriented Programming with C++ and OSF/Motif",
//    by Douglas Young, Prentice Hall, 1992. ISBN 0-13-630252-1
//
//    If you directly modify this file, you may lose your 
//    changes if it is  regenerated by the builder again.
//
//////////////////////////////////////////////////////////////
#ifndef DRCMAPCONTROL_H
#define DRCMAPCONTROL_H
#include <Vk/VkComponent.h>
#include "DrawwinDerived.h"


// Externally defined classes referenced by this class ;

class DrawwinDerived;
class DrcmapControlDerived;

class DrcmapControl : public VkComponent
{ 

  public:

    DrcmapControl(const char *, Widget);
    ~DrcmapControl();
    const char *  className();

  protected: 

    // Classes created by this class

    DrawwinDerived *_drawwin;

    // Widgets created by this class

    Widget  _drcmapControl;
    Widget  _frame;
    Widget  _list1;
    Widget  _listHeader;
    Widget  _nextCmap1;
    Widget  _pickList1;
    Widget  _prevCmap1;
    Widget  _rgbDisp;
    Widget  _rootList1;
    Widget  _scrolledWindow;


    // These virtual functions are called from the private callbacks (above)
    // Intended to be overriden in derived classes to define actions

    virtual void nextCmap ( Widget, XtPointer );
    virtual void normalBtnl ( Widget, XtPointer );
    virtual void normalBtnr ( Widget, XtPointer );
    virtual void pickCmap ( Widget, XtPointer );
    virtual void pickList ( Widget, XtPointer );
    virtual void prevCmap ( Widget, XtPointer );
    virtual void pushedBtnl ( Widget, XtPointer );
    virtual void pushedBtnr ( Widget, XtPointer );
    virtual void rootList ( Widget, XtPointer );

  private: 

    // Array of default resources

    static String      _defaultDrcmapControlResources[];

    // Callbacks to interface with Motif

    static void nextCmapCallback (Widget, XtPointer, XtPointer);
    static void normalBtnlCallback (Widget, XtPointer, XtPointer);
    static void normalBtnrCallback (Widget, XtPointer, XtPointer);
    static void pickCmapCallback (Widget, XtPointer, XtPointer);
    static void pickListCallback (Widget, XtPointer, XtPointer);
    static void prevCmapCallback (Widget, XtPointer, XtPointer);
    static void pushedBtnlCallback (Widget, XtPointer, XtPointer);
    static void pushedBtnrCallback (Widget, XtPointer, XtPointer);
    static void rootListCallback (Widget, XtPointer, XtPointer);

};
#endif

