/*
 * draw.h
 *
 * Copyright 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#define NOSVAL (-1)

typedef struct tagProgName {
    char *name;
    struct tagProgName *next;
} PROGNAME;

enum tagUsageType { Physical, Resident, Size, MappedObjects };

/*
 * Secondary types, for squeezing more info into each bar
 */
enum tagSecondType { None, Priv, Shared, Phys, Res };

typedef enum tagUsageType UsageType;
typedef enum tagSecondType SecondType;

extern PROGRAM * DrawSetup(PROGRAM *new, PROGRAM *old, long physMem,
			   long freeMem, UsageType type,
			   SecondType stype, int all,
			   int *barTotal, int *numBars);

extern void Resize(void);

extern void Init(PROGNAME *progNames, long threshHold);

extern void
Draw(PROGRAM *usageList, int barTotal, int numBars, char *progName,
     UsageType type, SecondType stype);

extern void DrawShadow(PROGRAM *usage, int barTotal, char *progName);

extern void SetThreshHold(long thresh);

extern void Help(void);

extern char * Select(PROGRAM *usage, long x, long y, int *procMode,
		     int dragging);

extern void WaitMessage(char *message, char *detail);
