/*
 * process.h
 *
 * Header file for process.c
 *
 * Copyright 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#define IRIX "Irix"

typedef struct tagProgram {
    /*
     * Stuff collected by GetProcInfo
     */
    char *progName;
    char *mapName, *mapType;
    long size, resSize, weightSize, privSize;
    int pid;
    int nProc;

    /*
     * Stuff used in drawing
     */
    int value;
    int secondValue;
    int labelOffset;
    int color;
    unsigned int skip : 1;
    unsigned int special : 1;
    unsigned int print : 1;
    long top, height, center;

    /*
     * List linkage
     */
    struct tagProgram *next, *prev;
} PROGRAM;

extern void GetProcInfo(char *procName, PROGRAM **all, PROGRAM **proc);

extern void FreeUsage(PROGRAM *usage);

extern void GetObjInfo(char *objName, PROGRAM **all, PROGRAM **objp);
