/**************************************************************************
 *
 * 		  Copyright (c)	1994 Silicon Graphics, Inc.
 *			All Rights Reserved
 *
 *	   THIS	IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SGI
 *
 * The copyright notice above does not evidence any actual of intended
 * publication of such source code, and is an unpublished work by Silicon
 * Graphics, Inc. This material contains CONFIDENTIAL INFORMATION that is
 * the property of Silicon Graphics, Inc. Any use, duplication or
 * disclosure not specifically authorized by Silicon Graphics is strictly
 * prohibited.
 *
 * RESTRICTED RIGHTS LEGEND:
 *
 * Use, duplication or disclosure by the Government is subject to
 * restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 52.227-7013,
 * and/or in similar or successor clauses in the FAR, DOD or NASA FAR
 * Supplement. Unpublished - rights reserved under the Copyright Laws of
 * the United States. Contractor is SILICON GRAPHICS, INC., 2011 N.
 * Shoreline Blvd., Mountain View, CA 94039-7311
 **************************************************************************
 *
 * File: Catalog.h
 *
 * Description: Header file for the catalog component.
 *
 **************************************************************************/


#ident "$Revision: 1.1 $"


#ifndef _CATALOG_H
#define _CATALOG_H


#include <Vk/VkComponent.h>
#include <Vk/VkComponentList.h>
#include "Deck.h"
#include <Vk/VkTabPanel.h>


/**************************************************************************
 *
 * Class: Catalog
 *
 * Description: Provides a deck of forms each with a tab.
 *
 **************************************************************************/

class Catalog: public VkComponent
{
    public:
	Catalog(const char *name, Widget parent);
	~Catalog();

	virtual const char *className();
	void addView(VkComponent *component, char *label);
	void removeView(VkComponent *component);
	Widget deckWidget() { return deck->baseWidget(); }
	int size() { return list->size(); }
	VkComponent* operator[](int index) const { return (*list)[index]; }
	VkComponent* getCurrent();
	void setCurrent(VkComponent *comp);
	void setTabLabel(char *label);

    private:
	VkComponentList *list;
	Deck *deck;
	VkTabPanel *tabs;

	void afterRealizeHook();
	void tabSelectedCB(VkCallbackObject *obj, void*, void*);
};


#endif /* _CATALOG_H */
