/**************************************************************************
 *
 * 		  Copyright (c)	1994 Silicon Graphics, Inc.
 *			All Rights Reserved
 *
 *	   THIS	IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SGI
 *
 * The copyright notice above does not evidence any actual of intended
 * publication of such source code, and is an unpublished work by Silicon
 * Graphics, Inc. This material contains CONFIDENTIAL INFORMATION that is
 * the property of Silicon Graphics, Inc. Any use, duplication or
 * disclosure not specifically authorized by Silicon Graphics is strictly
 * prohibited.
 *
 * RESTRICTED RIGHTS LEGEND:
 *
 * Use, duplication or disclosure by the Government is subject to
 * restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 52.227-7013,
 * and/or in similar or successor clauses in the FAR, DOD or NASA FAR
 * Supplement. Unpublished - rights reserved under the Copyright Laws of
 * the United States. Contractor is SILICON GRAPHICS, INC., 2011 N.
 * Shoreline Blvd., Mountain View, CA 94039-7311
 **************************************************************************
 *
 * File: Deck.h
 *
 * Description: Header file for the stacked deck component.
 *
 **************************************************************************/


#ident "$Revision: 1.1 $"


#ifndef _DECK_H
#define _DECK_H


#include <Vk/VkComponent.h>


// Forward reference for the WidgetList class

class VkWidgetList;


/**************************************************************************
 *
 * Class: Deck
 *
 * Description: Replaces the ViewKit deck component.
 *
 **************************************************************************/

class Deck: public VkComponent
{
    public:
        Deck(const char *name, Widget parent);
        ~Deck();

	void addView(Widget);
        void addView(VkComponent*);
        void removeView(VkComponent *component);

	void pop();
	void pop(Widget);
	void pop(VkComponent*);
	void push();
	void push(Widget);
	void push(VkComponent*);

	virtual const char* className();

    private:
	VkWidgetList *_children;
	int _current;

	void pushWidget(Widget w);
	void popWidget(Widget w);

	void afterRealizeHook();
};


#endif /* _DECK_H */
