
     GVI(1)                    UNIX System V                    GVI(1)

     NAME
          gvi - graphical vi command

     SYNOPSIS
          gvi [ X toolkitoption... ] [file ...]

     DESCRIPTION
          gvi provides a graphical user interface to the vi(1) text
          editor.  The gvi program window contains a menu bar at the
          top, the text editor window in the center and a set of tabs
          at the bottom. Each file being edited is given a tab. To
          select a file, click on the corresponding tab.  Within the
          text editor window all vi commands are available.

          If no files are specified on the command line, gvi will
          display an editor window with a tab labeled <noname>.

        Menu Bar
          The menu bar at the top of the program contains the
          following items:

                    File

                         New...    Open a new file for editing.
                                   Selecting this menu item pops up a
                                   dialog asking for the name of the
                                   new file. After entering the name,
                                   an editor window and tab will be
                                   created for the new file. If the
                                   file already exists, it will be
                                   opened for editing.

                         Open...   Open an existing file for editing.
                                   Selecting this menu item pops up a
                                   file selection dialog. Once a file
                                   has been selected, an editor window
                                   and tab will be created for the
                                   file. If the file selected is
                                   already being edited, gvi will
                                   issue a beep and pop the original
                                   copy of the file to the top of the
                                   tab stack. A duplicate editor
                                   window and tab will not be created.

                         Open Recent...
                                   Open one or more of the most
                                   recently opened files. Selecting
                                   this menu item pops up a list of
                                   the most recently opened files. One
                                   or more of the files on the list
                                   may be selected for editing. If a
                                   selected file is already being

     Page 1                                          (printed 6/30/94)

     GVI(1)                    UNIX System V                    GVI(1)

                                   edited, gvi will issue a beep and
                                   pop the original copy of the file
                                   to the top of the tab stack. A
                                   duplicate editor window and tab
                                   will not be created.  When a file
                                   is opened, gvi saves the file's
                                   full pathname and tab label in the
                                   file ~/.gvifiles. By default, a
                                   maximum of 15 of the most recently
                                   opened filenames are saved. The
                                   maximum number of files saved can
                                   be changed by setting the
                                   maxRecentFiles resource.

                         Close     Closes the currently selected file.
                                   Selecting this menu item is
                                   equivalent to typing :q in the
                                   editor window.

                         Close (with Save)
                                   Saves and closes the currently
                                   selected file. Selecting this menu
                                   item is equivalent to typing :wq in
                                   the editor window.

                         Close (no questions)
                                   Closes the currently selected file
                                   regardless of whether the file has
                                   been saved since it was last
                                   modified. Selecting this menu item
                                   is equivalent to typing :q! in the
                                   editor window.

                         Quit      Terminates the gvi program.

                    Selected

                         Change Tab Label...
                                   Selecting this menu item allows the
                                   text of the current tab to be
                                   changed.  New tab label text may be
                                   entered or the default text may be
                                   used. The default text for a tab is
                                   the basename of the currently
                                   selected file or <noname> if no
                                   file is being edited. A file's
                                   basename is the filename without
                                   any leading path.

                    Help      This is the standard application help
                              menu.

     Page 2                                          (printed 6/30/94)

     GVI(1)                    UNIX System V                    GVI(1)

        Editor Windows
          The central portion of the gvi program is taken up by the
          editor windows.  Each file being edited is contained in a
          separate editor window. Each editor window is running a
          separate copy of xwsh(1G) which in turn is executing vi. The
          editor windows are stacked on top of each other. To access
          an editor window select the tab for the corresponding file.
          Selecting a tab pops the editor window for that file to the
          top of the stack.  Editor windows accept all vi commands.

        Tabs
          Each tab represents a file being edited. To select a file
          click on the tab for the file. If there are more tabs than
          can fit across the program window, a set of overlapped tabs
          will be displayed on the left or right of the tab area.
          Selecting in this overlap area will pop up a menu of all
          available files.

     PROGRAM RESOURCES
          gvi is written using the standard X toolkit, the Motif
          widget set and the SGI ViewKit library. The program accepts
          all standard Xt/Motif resources and command line options. In
          addition to these resources the following resources are
          specific to the gvi program and may be specified by the
          user.

          maxRecentFiles (class MaxRecentFiles)
                         Specifies the maximum number of filenames
                         that gvi will remember in the most recently
                         opened file list.

          viWsh.numColumns (class viWsh.NumColumns)
                         Initial number of text columns to use for the
                         editor window.

          viWsh.numLines (class viWsh.NumLines)
                         Initial number of text lines to use for the
                         editor window.

     NOTES
          1.   Since gvi uses xwsh for its editor windows, the xwsh
               program resources may be used to configure the editor
               window. For example, the editor window background color
               can be set be specifying the XWsh*background resource
               in the .Xdefaults file.

          2.   If a new file is opened for editing directly from vi,
               the tab label for the editor window will not be updated
               with the new filename.

     SEE ALSO
          vi(1), xwsh(1G)

     Page 3                                          (printed 6/30/94)

     GVI(1)                    UNIX System V                    GVI(1)

     FILES
          /usr/lib/X11/app-defaults/Gvi                Program
                                                       resource file
          $HOME/.gvifiles                              Most recently
                                                       opened file
                                                       list
          /usr/lib/images/Gvi.icon                     Window manager
                                                       icon
          /usr/lib/filetype/install/gvi.ftr            Desktop file
                                                       typing rule
          /usr/lib/filetype/install/iconlib/gvi.fti    Desktop icon

     Page 4                                          (printed 6/30/94)


