/**************************************************************************
 *
 * 		  Copyright (c)	1994 Silicon Graphics, Inc.
 *			All Rights Reserved
 *
 *	   THIS	IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SGI
 *
 * The copyright notice above does not evidence any actual of intended
 * publication of such source code, and is an unpublished work by Silicon
 * Graphics, Inc. This material contains CONFIDENTIAL INFORMATION that is
 * the property of Silicon Graphics, Inc. Any use, duplication or
 * disclosure not specifically authorized by Silicon Graphics is strictly
 * prohibited.
 *
 * RESTRICTED RIGHTS LEGEND:
 *
 * Use, duplication or disclosure by the Government is subject to
 * restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 52.227-7013,
 * and/or in similar or successor clauses in the FAR, DOD or NASA FAR
 * Supplement. Unpublished - rights reserved under the Copyright Laws of
 * the United States. Contractor is SILICON GRAPHICS, INC., 2011 N.
 * Shoreline Blvd., Mountain View, CA 94039-7311
 **************************************************************************
 *
 * File: main.c++
 *
 * Description: Main program file for the graphical vi program, gvi.
 *
 **************************************************************************/


#ident "$Revision: 1.1 $"


#include <stdio.h>
#include <locale.h>
#include "MainWindow.h"
#include "common.h"


/**************************************************************************
 *
 * Function: main
 *
 * Description: Program entry point.
 *
 * Parameters: 
 *	argc (I) - number of command line parameters
 *	argv (I) - command line parameters
 *
 * Return: 0 if no errors during execution, 1 if errors encoutnered.
 *
 **************************************************************************/

int main(int argc, char **argv)
{
    DEFARGS(5);

    /*
     * Set up i18n
     */
    setlocale(LC_ALL, "");
    XtSetLanguageProc(NULL, NULL, NULL);

    VkApp *app = new VkApp("Gvi", &argc, argv);
    app->setVersionString(GVI_VERSION);
    STARTARGS;
    SETARG(XmNallowShellResize, True);
    MainWindow *mainWindow = new MainWindow("gvi", ARGLIST);

    app->run();

    /* NOTREACHED */
    return 1;
}
