/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
//
//  Class:		ConfList
//  Base Classes:       none
//
//  Class:		GroupList
//  Base Classes:       ConfList
//
//  Author:             Jesse Rendleman (jesse@sgi.com)
//

// X11/motif includes
#include <Xm/Xm.h>


class ConfList {
  private:
  protected:
    int _numItems;
    char _item[30];
    Widget _dWidget;
    Widget _listWidget;
    static void okCB(Widget, XtPointer, XtPointer);
    static void cancelCB(Widget, XtPointer, XtPointer);

  public:
    ConfList();
    ~ConfList();
    virtual void init(Widget, char*);
    virtual void open();
    virtual void clear();
    virtual Boolean add(char* item, Boolean select=FALSE);
    virtual Boolean select(char* item);
    virtual Boolean remove(char* item);
    virtual Boolean find(char* item);
    virtual Boolean findSelected(char* item);
};


extern class ConfDoc;

class GroupList : public ConfList {
  private:
  protected:
    ConfDoc* _confdoc;
    static void okCB(Widget, XtPointer, XtPointer);

  public:
    GroupList();
    ~GroupList();
    virtual void init(Widget, char*, ConfDoc* cd);
};


class PrivateList : public ConfList {
  private:
  protected:
    ConfDoc* _confdoc;
    Widget _privateText;
    char _user[30];
    static void closeCB(Widget, XtPointer, XtPointer);
    static void sendCB(Widget, XtPointer, XtPointer);

  public:
    PrivateList();
    ~PrivateList();
    virtual void init(Widget, char*, char*, ConfDoc* cd);
};


