/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
//
//  Class:              ConfList
//  Base Classes:       none
//  Author:             Jesse Rendleman (jesse@sgi.com)
//

// motif includes
#include <Xm/Text.h>

#define MAX_BUF_SIZE 256

enum ConfTextReason { TIO_input };

typedef struct {
  ConfTextReason reason;
  class ConfText* confTextObj;
  char* value;
} ConfTextCallback;

class ConfText {
  protected:
    void prepTextWidget();

    Widget _text;
    char* _buffer;
    char* _prompt;
    int _promptSize;
    int _lineCount;
    Boolean _ignoreVerify;

  public:
    ConfText(Widget textWidget, const char* prompt);
    ~ConfText();

    void clearHistory();
    void putStr(char* str, Boolean hilite=FALSE);
    void putChr(char ch);
};

