/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

// unix includes
#include <stdlib.h>
#include <signal.h>
#include <getopt.h>

// conf includefile
#include "ConfDoc.h"

#ifdef sgi
extern "C" {
extern void VkLoadScheme(Display*);
};
#endif

ConfDoc *theDoc = NULL;  // oh, so what if I break down and use a global..

static void quit( int ... )
{
   // exit gracefully
   theDoc->quitCB(NULL, (XtPointer)theDoc, NULL);
}


void main(int argc, char **argv)
{  
   signal(SIGHUP,  quit);
   signal(SIGINT,  quit);
   signal(SIGQUIT, quit);
   signal(SIGPOLL, SIG_IGN);

   // Initialize the Intrinsics
   XtAppContext app;
   Widget _toplevel = XtAppInitialize(&app, "XConf", NULL, 0,
			&argc, argv, NULL, NULL, 0);

#ifdef sgi
#ifndef sherwood
   VkLoadScheme(XtDisplay(_toplevel));
#endif
#endif

   int port = DEFPORT;
   char* server = NULL;
   extern char* optarg;
   extern int optind, opterr;
   int c;
   while ((c = getopt(argc, argv, "s:,p:")) != EOF) {
      switch (c) {
         case 's':
            server = (char*)malloc(MAXHOSTNAMELEN * sizeof(char));
            strcpy(server, optarg);
            fprintf(stderr, "server = %s\n", server);
            break;
         case 'p':
            port = atoi(optarg);
            break;
         case '?':
            fprintf(stderr, "Usage: xconf [-s server] [-p port]\n");
            exit(-1);
      }
   }

   // create the ConfDoc
   theDoc = new ConfDoc(app, "xconf");

   // build the ConfDoc
   theDoc->build(_toplevel);

   // initialize the ConfDoc
   theDoc->init(port, server);

   // Realize the widgets and enter the event loop.
   XtRealizeWidget(_toplevel);
   XtAppMainLoop(app);
}

